package com.supermap.mutiviewport;

import com.supermap.data.Environment;
import com.supermap.data.LicenseStatus;
import com.supermap.data.Workspace;
import com.supermap.data.WorkspaceConnectionInfo;
import com.supermap.data.WorkspaceType;
import com.supermap.realspace.Layer3D;
import com.supermap.realspace.Layer3Ds;
import com.supermap.realspace.MultiViewportMode;
import com.supermap.realspace.Scene;
import com.supermap.realspace.SceneControl;
import com.supermap.realspace.SceneControl.SceneControlInitedCallBackListenner;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.Toast;


/**
 * <p>
 * Title: Multi-screen
 * </p>
 * 
 * <p>
 * Description:
 * ============================================================================>
 * ------------------------------Statement----------------------------
 * This is SuperMap iMobile for Android Sample Code 
 * Copyright: SuperMap Software Co., Ltd.
 * ----------------------------------------------------------------
 * ---------------------SuperMap iMobile for Android Sample Code------------------------
 * 
 * 1. Introduction: How to use the multi-screen 2. Data: CBD_android 3. Members: SceneControl.getScene
 *  Scene.open, Scene.setMultiViewportMode(MultiViewportMode multiViewportMode );
 * 
 * 4. Steps: (1)Copy the SampleData/CBD_android/ to the Android sd /sdcard/SampleData/
 * (2)Scene name: CBD_android
 * (3)Run the program, and load the scene.
 * (4)User can select the multi-screen according to the buttons. For exammple, horizontal  screen, vertical screen, two-screen, three-screen, and four-screen.
 * -----------------------------------------------------------------------------
 * -
 * ============================================================================>
 * </p>
 * 
 * <p>
 * Company: SuperMap Software Co., Ltd.
 * </p>
 * 
 */
@SuppressLint("ShowToast")
public class MainActivity extends Activity {
  
	private SceneControl mSceneControl;
	
	private Button btn_none,btn_quad,btn_triple,btn_vertical,btn_horizontal;
	private Workspace m_workspace;
	WorkspaceConnectionInfo info;
	WorkspaceType workspaceTypetemp = null;
	@SuppressLint("SdCardPath")
	String workspacePath = "/sdcard/SampleData/CBD_android/CBD_android.sxwu";
	// 3D scene name
	String sceneName = "CBD_android";
	private final String sdcard = android.os.Environment.getExternalStorageDirectory().getAbsolutePath().toString();
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		Environment.setLicensePath(sdcard+"/SuperMap/license/");
		Environment.initialization(this);
		setFullScreen();
		setContentView(R.layout.activity_main);
		mSceneControl=(SceneControl)findViewById(R.id.sceneControl);
		btn_none=(Button)findViewById(R.id.btn_none);
		btn_quad=(Button)findViewById(R.id.btn_quad);
		btn_triple=(Button)findViewById(R.id.btn_triple);
		btn_vertical=(Button)findViewById(R.id.btn_vertical);
		btn_horizontal=(Button)findViewById(R.id.btn_horizontal);
		
		//Initialized open the local scene.

        mSceneControl.sceneControlInitedComplete(new SceneControlInitedCallBackListenner() {
					
					@Override
					public void onSuccess(String success) {
						if(isLicenseAvailable()){
							openLocalSence();
						}
						
					}
				});
		/**
		 * Exit the Multi-screen
		 */
		btn_none.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View arg0) {
				// TODO Auto-generated method stub
				mSceneControl.getScene().setMultiViewportMode(MultiViewportMode.RealspaceMultiViewportModeNone);
			}
		});
		
		/**
		 * Horizontal multi-screen
		 */
		btn_horizontal.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View arg0) {
				// TODO Auto-generated method stub
				Scene scene=mSceneControl.getScene();
				scene.setMultiViewportMode(MultiViewportMode.RealspaceMultiViewportModeHorizontal);
				Layer3Ds layer3ds=scene.getLayers();
				Layer3D  layer3dA=layer3ds.get("buildingPlanA");
				layer3dA.setVisibleInViewport(0, true);
				layer3dA.setVisibleInViewport(1, false);
				Layer3D  layer3dB=layer3ds.get("buildingPlanB");
				layer3dB.setVisible(true);
				layer3dB.setVisibleInViewport(0, false);
				layer3dB.setVisibleInViewport(1, true);
			}
		});
		
		/**
		 * Vertical multi-screen
		 */
		btn_vertical.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View arg0) {
				// TODO Auto-generated method stub
				Scene scene=mSceneControl.getScene();
				scene.setMultiViewportMode(MultiViewportMode.RealspaceMultiViewportModeVertical);
				Layer3Ds layer3ds=scene.getLayers();
				Layer3D  layer3dA=layer3ds.get("buildingPlanA");
				layer3dA.setVisibleInViewport(0, true);
				layer3dA.setVisibleInViewport(1, false);
				Layer3D  layer3dB=layer3ds.get("buildingPlanB");
				layer3dB.setVisible(true);
				layer3dB.setVisibleInViewport(0, false);
				layer3dB.setVisibleInViewport(1, true);
			}
		});
		/**
		 * Three-screen
		 */
		btn_triple.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View arg0) {
				// TODO Auto-generated method stub
				Scene scene=mSceneControl.getScene();
				scene.setMultiViewportMode(MultiViewportMode.RealspaceMultiViewportModeTriple);
				Layer3Ds layer3ds=scene.getLayers();
				Layer3D  layer3dA=layer3ds.get("buildingPlanA");
				layer3dA.setVisibleInViewport(0, true);
				layer3dA.setVisibleInViewport(1, false);
				layer3dA.setVisibleInViewport(2, true);
				Layer3D  layer3dB=layer3ds.get("buildingPlanB");
				layer3dB.setVisible(true);
				layer3dB.setVisibleInViewport(0, false);
				layer3dB.setVisibleInViewport(1, true);
				layer3dB.setVisibleInViewport(2, true);
			}
		});
		/**
		 * Four-screen
		 */
		btn_quad.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View arg0) {
				// TODO Auto-generated method stub
				Scene scene=mSceneControl.getScene();
				scene.setMultiViewportMode(MultiViewportMode.RealspaceMultiViewportModeQuad);
				Layer3Ds layer3ds=scene.getLayers();
				Layer3D  layer3dA=layer3ds.get("buildingPlanA");
				layer3dA.setVisibleInViewport(0, true);
				layer3dA.setVisibleInViewport(1, false);
				layer3dA.setVisibleInViewport(2, true);
				layer3dA.setVisibleInViewport(3, false);
				Layer3D  layer3dB=layer3ds.get("buildingPlanB");
				layer3dB.setVisible(true);
				layer3dB.setVisibleInViewport(0, false);
				layer3dB.setVisibleInViewport(1, true);
				layer3dB.setVisibleInViewport(2, false);
				layer3dB.setVisibleInViewport(3, true);
			}
		});
	}
	/**
	 * Open the local scene
	 */
	private void openLocalSence(){
		// Create a new workspace object
		if (m_workspace == null) {
			m_workspace = new Workspace();
		}
		if (info == null) {
			info = new WorkspaceConnectionInfo();
		}
		// Set the server path and type according to the workspace type.
		
		workspaceTypetemp = WorkspaceType.SXWU;
		info.setServer(workspacePath);
		info.setType(workspaceTypetemp);
		// The scene associates to the workspace
		if (m_workspace.open(info)) {
			Scene m_scene = mSceneControl.getScene();
			m_scene.setWorkspace(m_workspace);
		}
		// Open the scene
		boolean successed = mSceneControl.getScene().open(sceneName);
		if (successed) {
			Toast.makeText(MainActivity.this, "Open the scene successfully", Toast.LENGTH_LONG);
		}
	}
	// Determine whether the license is available
		private boolean isLicenseAvailable() {

			LicenseStatus licenseStatus = Environment.getLicenseStatus();
			boolean a = licenseStatus.isLicenseValid();
			if (!licenseStatus.isLicenseExsit()) {
				Toast.makeText(MainActivity.this, "The license does not exist. Failed to open the scene. Please add the license", Toast.LENGTH_LONG).show();
				return false;
			} else if (!licenseStatus.isLicenseValid()) {
				Toast.makeText(MainActivity.this, "The license is expired. Failed to open the scene. Please change the available license", Toast.LENGTH_LONG).show();
				return false;
			}
			return true;
		}
		//Full screen
		private void setFullScreen() {
			requestWindowFeature(Window.FEATURE_NO_TITLE);
			getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN,
					WindowManager.LayoutParams.FLAG_FULLSCREEN);
		}
}
